var THE_TREEMAP;

function init() {
	THE_TREEMAP = new $jit.TM.Squarified({
		//where to inject the visualization
		injectInto: 'infovis',
		//parent box title heights
		titleHeight: 15,
		//enable animations
		animate: false,
		//box offsets
		offset: 1,
		//Attach left and right click events
		Events: {
			enable: true,
			onClick: function(node) {
				//if(node) tm.enter(node);
				if (node) {
					ssbcallback("select", node.id);
				}
			},
			onRightClick: function() {
				//tm.out();
			}
		},
		duration: 0,
		//Enable tips
		Tips: {
			enable: true,
			//add positioning offsets
			offsetX: 20,
			offsetY: 20,
			//implement the onShow method to
			//add content to the tooltip when a node
			//is hovered
			onShow: function(tip, node, isLeaf, domElement) {
				var html = "<div class=\"tip-title\">" + node.name + "</div><div class=\"tip-text\">";
				var data = node.data;
				if (data.playcount) {
					html += "play count: " + data.playcount;
				}
				if (data.image) {
					html += "<img src=\"" + data.image + "\" class=\"album\" />";
				}
				tip.innerHTML = html;
			}
		},
		//Add the name of the node in the correponding label
		//This method is called once, on label creation.
		onCreateLabel: function(domElement, node) {
			domElement.innerHTML = node.name;
			var style = domElement.style;
			style.display = '';
			style.border = '1px solid transparent';
			domElement.onmouseover = function() {
				style.border = '1px solid #9FD4FF';
			};
			domElement.onmouseout = function() {
				style.border = '1px solid transparent';
			};
		}
	});

	//var util = $jit.util;
	//util.extend(tm, new $jit.Layouts.TM.Squarified);
	//tm.refresh();
	//util.extend(tm, new $jit.Layouts.TM.Strip);
}

function onssbmessage (cmd, val) {
	if (cmd == "updated") {
		update_list ();
	}
	else if (cmd == "selected") {
	}
}

function update_list () {
	$.getJSON("ssb-json://localhost/allEntries.json", function(json) {
		var v = {
			"children": json,
			"id": "allentries",
			"name": "entries"
		};
		THE_TREEMAP.loadJSON(v);
		THE_TREEMAP.refresh();
	});
}

$(function() {
	init ();
});
